library("e1071")

bcpred <- new.env()

with(bcpred, {
	svm.lt <- readRDS(file="svmr_lt.rds")
	svm.at <- readRDS(file="svmr_at.rds")

	predict.bc <- function(mdl, l3l4.at, l3l4.lt, l4l5.at, l4l5.lt, mt.at, mt.lt)
	{
		if(is.null(l3l4.at) | is.null(l3l4.lt) | is.null(l4l5.at) | is.null(l4l5.lt) | is.null(mt.at) | is.null(mt.lt))
			stop("None of the parameters can be null.")
			
		n <- length(l3l4.at)
		if(n != length(l3l4.lt)) stop("L3L4 LT of incorrect length.")
		if(n != length(l4l5.at)) stop("L4L5 AT of incorrect length.")
		if(n != length(l4l5.lt)) stop("L4L5 LT of incorrect length.")
		if(n != length(mt.at)) stop("MT AT of incorrect length.")
		if(n != length(mt.lt)) stop("MT LT of incorrect length.")
	
		all <- data.frame(		
			l3l4.at = l3l4.at,
			l3l4.lt = l3l4.lt,
			l4l5.at = l4l5.at,
			l4l5.lt = l4l5.lt,
			mt.at = mt.at,
			mt.lt = mt.lt)
		 
		p <- predict(mdl, newdata=all)
		
		return(p)
	}

	lt.multi.alj <- function(l3l4.at, l3l4.lt, l4l5.at, l4l5.lt, mt.at, mt.lt)
	{
		predict.bc(bcpred$svm.lt, l3l4.at, l3l4.lt, l4l5.at, l4l5.lt, mt.at, mt.lt)
	}
	
	at.multi.alj <- function(l3l4.at, l3l4.lt, l4l5.at, l4l5.lt, mt.at, mt.lt)
	{
		predict.bc(bcpred$svm.at, l3l4.at, l3l4.lt, l4l5.at, l4l5.lt, mt.at, mt.lt)
	}

}) # with(bcpred,